import odeToJava.modules.*;

public class F2 implements ODE
{
     // constructors

     public F2(int mode)   // constructor needed for piecewise function becuase it depends
     {   // on the mode, but it still properly overloads f and g, so this is legal
          this.mode = mode;
     }

     // methods

     public double[] f(double t, double[] x)
     {
          double[] x_prime = new double[x.length];

          switch(mode)
          {
               case 1:   // piece 1
                    x_prime[0] = 55.0 - 3.0*x[0]/2.0; 
               break;
               case 2:   // piece 2
                    x_prime[0] = 55.0 - x[0]/2.0;
               break;
               default:   // if user inputs number other than 1 or 2 pass back 0
                    x_prime[0] = 0.0;
               break;
          }

          return(x_prime);
     }

     public double[] g(double t, double[] x)
     {
          double[] event = new double[x.length];

          event[0] = Math.sin(Math.PI*t);   // event occurs when t is equal to a mathematical integer

          return(event);
     }

     // instance vars

     private int mode;   // which piece of the piecewise function to use
}